### A free/open-source library for quantitative finance

Public Types | Public Member Functions
GenericRiskStatistics< S > Class Template Reference

empirical-distribution risk measures More...

`#include <ql/math/statistics/riskstatistics.hpp>`

Inherits S.

List of all members.

## Public Types

typedef S::value_type | value_type

## Public Member Functions

Real | semiVariance () const
Real | semiDeviation () const
Real | downsideVariance () const
Real | downsideDeviation () const
Real | regret (Real target) const
Real | potentialUpside (Real percentile) const
| potential upside (the reciprocal of VAR) at a given percentile
Real | valueAtRisk (Real percentile) const
| value-at-risk at a given percentile
Real | expectedShortfall (Real percentile) const
| expected shortfall at a given percentile
Real | shortfall (Real target) const
Real | averageShortfall (Real target) const

## Detailed Description

### template<class S>
class QuantLib::GenericRiskStatistics< S >

empirical-distribution risk measures

This class wraps a somewhat generic statistic tool and adds a number of risk measures (e.g.: value-at-risk, expected shortfall, etc.) based on the data distribution as reported by the underlying statistic tool.

Possible enhancements:
  add historical annualized volatility

Examples:
  DiscreteHedging.cpp.

## Member Function Documentation

Real semiVariance | ( |  | ) | const

returns the variance of observations below the mean,

See Markowitz (1959).

Real semiDeviation | ( |  | ) | const

returns the semi deviation, defined as the square root of the semi variance.

Real downsideVariance | ( |  | ) | const

returns the variance of observations below 0.0,

Real downsideDeviation | ( |  | ) | const

returns the downside deviation, defined as the square root of the downside variance.

Real regret | ( | Real | target | ) | const

returns the variance of observations below target,

See Dembo and Freeman, "The Rules Of Risk", Wiley (2001).

Real potentialUpside | ( | Real | centile | ) | const

potential upside (the reciprocal of VAR) at a given percentile

Precondition:
  percentile must be in range [90%-100%)

Real valueAtRisk | ( | Real | centile | ) | const

value-at-risk at a given percentile

Precondition:
  percentile must be in range [90%-100%)

Real expectedShortfall | ( | Real | centile | ) | const

expected shortfall at a given percentile

returns the expected loss in case that the loss exceeded a VaR threshold,

that is the average of observations below the given percentile . Also know as conditional value-at-risk.

See Artzner, Delbaen, Eber and Heath, "Coherent measures of risk", Mathematical Finance 9 (1999)

Precondition:
  percentile must be in range [90%-100%)

Real shortfall | ( | Real | target | ) | const

probability of missing the given target, defined as

where

Real averageShortfall | ( | Real | target | ) | const

averaged shortfallness, defined as